## com.google.javascript.jscomp.ant
Class CompileTask

    java.lang.Object
      org.apache.tools.ant.ProjectComponent
          org.apache.tools.ant.Task
              com.google.javascript.jscomp.ant.CompileTask

All Implemented Interfaces:
  Cloneable

    public final class CompileTask

extends org.apache.tools.ant.Task

This class implements a simple Ant task to do almost the same as CommandLineRunner. Most of the public methods of this class are entry points for the Ant code to hook into.

Field Summary

Fields inherited from class org.apache.tools.ant.Task
`target, taskName, taskType, wrapper`

Fields inherited from class org.apache.tools.ant.ProjectComponent
`description, location, project`

Constructor Summary
`CompileTask()`

Method Summary
`void` | `addExterns(org.apache.tools.ant.types.FileList list)` Sets the externs file.
`void` | `addPath(org.apache.tools.ant.types.Path list)` Adds a <path/> entry.
`void` | `addSources(org.apache.tools.ant.types.FileList list)` Sets the source files.
`void` | `addWarning(Warning warning)` Adds a <warning/> entry Each warning entry must have two attributes, group and level.
`org.apache.tools.ant.types.Parameter` | `createDefine()` Creates a new `<define/>` nested element.
`void` | `execute()`
`void` | `setCompilationLevel(String value)` Set the compilation level.
`void` | `setCustomExternsOnly(boolean value)` Use only custom externs.
`void` | `setDebug(boolean value)` Enable debugging options.
`void` | `setEncoding(String encoding)` Set input file encoding
`void` | `setForceRecompile(boolean forceRecompile)` Set force recompile option
`void` | `setGenerateExports(boolean generateExports)` Set generateExports option
`void` | `setManageDependencies(boolean value)`
`void` | `setOutput(File value)` Set output file.
`void` | `setOutputEncoding(String outputEncoding)` Set output file encoding
`void` | `setPrettyPrint(boolean pretty)` Set pretty print formatting option
`void` | `setPrintInputDelimiter(boolean print)` Set print input delimitter formatting option
`void` | `setReplaceProperties(boolean value)` Whether to replace `@define` lines with properties
`void` | `setReplacePropertiesPrefix(String value)` Set the replacement property prefix.
`void` | `setWarning(String value)` Set the warning level.

Methods inherited from class org.apache.tools.ant.Task
`bindToOwner, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, init, isInvalid, log, log, log, log, maybeConfigure, perform, reconfigure, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`

Methods inherited from class org.apache.tools.ant.ProjectComponent
`clone, getDescription, getLocation, getProject, setDescription, setLocation, setProject`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CompileTask

    public CompileTask()

Method Detail

### setWarning

    public void setWarning(String value)

  Set the warning level.

  Parameters:
    `value` - The warning level by string name. (default, quiet, verbose).

### setDebug

    public void setDebug(boolean value)

  Enable debugging options.

  Parameters:
    `value` - True if debug mode is enabled.

### setCompilationLevel

    public void setCompilationLevel(String value)

  Set the compilation level.

  Parameters:
    `value` - The optimization level by string name. (whitespace, simple, advanced).

### setManageDependencies

    public void setManageDependencies(boolean value)

### setCustomExternsOnly

    public void setCustomExternsOnly(boolean value)

  Use only custom externs.

### setOutput

    public void setOutput(File value)

  Set output file.

### setReplacePropertiesPrefix

    public void setReplacePropertiesPrefix(String value)

  Set the replacement property prefix.

### setReplaceProperties

    public void setReplaceProperties(boolean value)

  Whether to replace `@define` lines with properties

### setEncoding

    public void setEncoding(String encoding)

  Set input file encoding

### setOutputEncoding

    public void setOutputEncoding(String outputEncoding)

  Set output file encoding

### setPrettyPrint

    public void setPrettyPrint(boolean pretty)

  Set pretty print formatting option

### setPrintInputDelimiter

    public void setPrintInputDelimiter(boolean print)

  Set print input delimitter formatting option

### setForceRecompile

    public void setForceRecompile(boolean forceRecompile)

  Set force recompile option

### setGenerateExports

    public void setGenerateExports(boolean generateExports)

  Set generateExports option

### addExterns

    public void addExterns(org.apache.tools.ant.types.FileList list)

  Sets the externs file.

### addWarning

    public void addWarning(Warning warning)

  Adds a <warning/> entry Each warning entry must have two attributes, group and level. Group must contain one of the constants from DiagnosticGroups (e.g., "ACCESS_CONTROLS"), while level must contain one of the CheckLevel constants ("ERROR", "WARNING" or "OFF").

### addSources

    public void addSources(org.apache.tools.ant.types.FileList list)

  Sets the source files.

### addPath

    public void addPath(org.apache.tools.ant.types.Path list)

  Adds a <path/> entry.

### execute

    public void execute()

  Overrides:
    `execute` in class `org.apache.tools.ant.Task`

### createDefine

    public org.apache.tools.ant.types.Parameter createDefine()

  Creates a new `<define/>` nested element. Supports name and value attribtues.